LeetCode947. Most Stones Removed with Same Row or Column——并查集

文章目录

    • 一、题目
    • 二、题解

一、题目

On a 2D plane, we place n stones at some integer coordinate points. Each coordinate point may have at most one stone.

A stone can be removed if it shares either the same row or the same column as another stone that has not been removed.

Given an array stones of length n where stones[i] = [xi, yi] represents the location of the ith stone, return the largest possible number of stones that can be removed.

Example 1:

Input: stones = [[0,0],[0,1],[1,0],[1,2],[2,1],[2,2]]
Output: 5
Explanation: One way to remove 5 stones is as follows:

  1. Remove stone [2,2] because it shares the same row as [2,1].
  2. Remove stone [2,1] because it shares the same column as [0,1].
  3. Remove stone [1,2] because it shares the same row as [1,0].
  4. Remove stone [1,0] because it shares the same column as [0,0].
  5. Remove stone [0,1] because it shares the same row as [0,0].
    Stone [0,0] cannot be removed since it does not share a row/column with another stone still on the plane.
    Example 2:

Input: stones = [[0,0],[0,2],[1,1],[2,0],[2,2]]
Output: 3
Explanation: One way to make 3 moves is as follows:

  1. Remove stone [2,2] because it shares the same row as [2,0].
  2. Remove stone [2,0] because it shares the same column as [0,0].
  3. Remove stone [0,2] because it shares the same row as [0,0].
    Stones [0,0] and [1,1] cannot be removed since they do not share a row/column with another stone still on the plane.
    Example 3:

Input: stones = [[0,0]]
Output: 0
Explanation: [0,0] is the only stone on the plane, so you cannot remove it.

Constraints:

1 <= stones.length <= 1000
0 <= xi, yi <= 104
No two stones are at the same coordinate point.

二、题解

所有能算在一个集合里的石子,最后都可以被消为只剩最里面那个石子。

class Solution {
public:
    int father[1001];
    int nums;
    int removeStones(vector<vector<int>>& stones) {
        unordered_map<int,int> row,col;
        int n = stones.size();
        build(n);
        for(int i = 0;i < n;i++){
            int r = stones[i][0],c = stones[i][1];
            if(row.find(r) == row.end()) row[r] = i;
            else unions(i,row[r]);
            if(col.find(c) == col.end()) col[c] = i;
            else unions(i,col[c]);
        }
        return n - nums;
    }
    void build(int m){
        for(int i = 0;i < m;i++){
            father[i] = i;
        }
        nums = m;
    }
    int find(int x){
        if(x != father[x]) father[x] = find(father[x]);
        return father[x];
    }
    void unions(int x,int y){
        int fx = find(x),fy = find(y);
        if(fx != fy){
            father[fx] = fy;
            nums--;
        }
    }
};

你可能感兴趣的:(算法,数据结构,leetcode,c++,并查集)